  
"
    __________________________________________________
    @Alejandro F. Reimondo 01/04/99
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

Object subclass: #SystemDumper
  instanceVariableNames: 
    ' notifier '
  classVariableNames: ''
  poolDictionaries: ''  !

SystemDumper class instanceVariableNames: ' current '  !


!SystemDumper class methods !

current
    "Returns the instance var of the receiver
     for external manipulation"
    ^current!
  
current: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    current := anObject!
 
startUp
	"Start an instance of the receiver.
	SystemDumper startUp.
	"

	self current: self new.
	^current run! !



!SystemDumper methods !
  
cr
	"Send a cr to the notifier."

	self notifier cr.!

dumpClass: aClass level: level
	" Private - Dump the class aClass (and it's subclasses) onto the receiover's notifier. "

	| tab |
	tab := ' '.
	self cr.
	level timesRepeat: [ self nextPutAll: tab ].
	self nextPutAll: '|',aClass name.
	"
	(aClass inheritsFrom: OLEInterface)
		ifTrue: [ self nextPutAll: 'iid:',aClass iid asString ].
	"
	aClass subclasses do: [:each| self dumpClass: each level: level + 1 ].!
   
dumpClasses
	" Private - Dump the classes of the system on the notifier. "

	self nextPutAll: 'Classes in the system:'.
	Smalltalk rootClasses do: [:root|
		self dumpClass: root level: 0
	].!
   
initializeNotifier
	" Private - Initializes the receiver's notifier.
	We will try to use a text window notifier if posible,
		 else we will do output on a file."

	(Smalltalk includesKey: #TextWindow)
	ifFalse: [
		^notifier := File newFile: self class name,'.log'.
	].

	notifier :=  (Smalltalk at: #TextWindow) new
		label: self class name,' Notifier ';
		open;
		yourself.!
   
nextPutAll: aString
	"Send aString to the notifier."

	self notifier nextPutAll: aString asString.
	(self notifier respondsTo: #flush)
	ifTrue: [ self notifier flush ].!
  
notifier
    "Returns the instance var of the receiver
     for external manipulation"

	notifier isNil ifTrue: [ self initializeNotifier ].
    ^notifier!

notifier: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    notifier := anObject!
   
run
	"Run the receiver's dump on a file."

	self
		dumpClasses;
		yourself! !
