  
"
    __________________________________________________
    @Alejandro F. Reimondo [mailTo:aleReimondo@sugarWeb.com] 12/05/99
    This proyect sources are property of : Alejandro F. Reimondo [mailTo:aleReimondo@sugarWeb.com]
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

OLEObject subclass: #VS4WEBComponent
  instanceVariableNames: 
    ' iVS4WEB window receiver selector argument errorDescription bindings commands dialog useProgressDialogs confirmErrors '
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants OLEConstants OLEStatusCodeConstants '  !

VS4WEBComponent subclass: #VS4WEBAutomationServer
  instanceVariableNames: 
    ' automationServer '
  classVariableNames: ''
  poolDictionaries: 
    ' OLEAutomationConstants OLEConstants OLEStatusCodeConstants ' !

VS4WEBAutomationServer class instanceVariableNames: ' current '    !

IUnknown subclass: #IVS4WEB
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

IUnknownImplementation subclass: #IVS4WEBImplementation
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' OLEStatusCodeConstants '   !

IUnknownPointer variableByteSubclass: #IVS4WEBPointer
  classVariableNames: ''
  poolDictionaries: ''    !

SubPane subclass: #ActivexPane
  instanceVariableNames: 
    ' mouse '
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants VirtualKeyConstants ' !

ApplicationCoordinator subclass: #ActivexCoordinator
  instanceVariableNames: 
    ' window '
  classVariableNames: ''
  poolDictionaries: ''  !

ARObject subclass: #SmalltalkLibraryBinderWrapper
  instanceVariableNames: 
    ' binder '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #SmalltalkLibraryBinderWrapper) comment: '
	@1999 - Alejandro Reimondo
	mailTo: aleReimondo@sugarWeb.com
	SmalltalkLibraryBinderWrappers are alternative binders to support other kind of bindings.
'  !

SmalltalkLibraryBinderWrapper class instanceVariableNames: ' binderClass ' !

SmalltalkLibraryBinderWrapper subclass: #ZippedLibraryBinder
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #ZippedLibraryBinder) comment: '
	@1999 - Alejandro Reimondo
	mailTo: aleReimondo@sugarWeb.com
	ZippedLibraryBinder is a binder that can find SLLs inside Zip files.
'    !


!VS4WEBComponent class methods !
 
clsid
        " Answer the CLSID of instances of the receiver. "

    " '{08B9DF82-CF53-11D2-9452-000001252013}' asGUID "
    ^GUID fromBytes: #[ 16r82 16rDF 16rB9 8 16r53 16rCF 16rD2 16r11 16r94 16r52 0 0 1 16r25 16r20 16r13 ]!

installComponent
    "Install the receiver's component."

    IVS4WEB registerIID.
    SessionModel current isRunTime
    ifTrue: [
        SessionModel current
            when: #startUpApplication
            send: #startUpApplication to: self
    ].!
  
notifier
	"Returns the notifier/debugger stream (if present or nil)."

	^(Smalltalk at: #SystemDumper ifAbsent: [^nil]) current!
 
notify: aString
	"Dump aString onto the notifier."

	| notifier |
	notifier := self notifier.
	notifier notNil ifTrue: [ notifier cr;nextPutAll: aString ].!
   
oleTRACE
	" Private - Log a new line to the OLE debug trace log."

    self oleTRACE: String new.!
   
oleTRACE: aString
        " Log the debugging message <aString> to the OLE debug trace log.
        Tracing to a log file can be enabled in a runtime application by
        installing a library containing OLETraceManager. "

    OLESessionManager traceManager isNil ifTrue: [ ^nil ].
    OLESessionManager traceManager traceEnabled
        ifFalse: [ OLESessionManager traceManager logToFile ].
    OLESessionManager traceManager reportTRACE: aString.!

registerClassFactory
    " Register the class factory for the receiver.
      Answer whether successful. "

    self oleTRACE: 'Registering class factory for ', self name, ' ( CLSID ', self clsid printString, ' ) ...'.
    [ self newClassFactory registerAsMultipleUseLocalServer ]
    on: OLEError do: [ :ex |
        self
            oleTRACE: '***ERROR: class factory registration failed.'.
            ^false
    ].
    self oleTRACE: '... done'.
    ^true!

removeComponent
    " Remove (unInstall) the component "

    IVS4WEB removeIID.!

show: aString
	"Dump aString onto the notifier."

	^self notify: aString.!
   
startUpApplication
    "Start up the object server application."

    self
        oleTRACE;
        oleTRACE: 'Starting OLE object server application ',
            ' (', Date today printString, ' ', Time now printString, ')';
        oleTRACE: '    CLSID: ',             self clsid printString;
        oleTRACE: '    Session command line: ', SessionModel current commandLine asArray printString.

    OLESessionManager isOLEAvailable
    ifFalse: [
        self
            oleTRACE: 'Terminating session (OLE not available or incorrect version)';
            oleTRACE.
        SessionModel current exitSession
    ].

    OLESessionManager sessionStartedToServiceObjects
    ifFalse: [
        self
            oleTRACE: 'Terminating session (not started to service objects)';
            oleTRACE.
        SessionModel current exitSession
    ].

    self registerClassFactory
        ifFalse: [
            MessageBox notify: 'Terminating OLE object server application'
                withText: 'Class factory registration for ', self name, ' failed.'.
            SessionModel current exitSession ].

    OLEClassFactoryObject exitIfNotInUse: true.
    SessionModel current
        when: #shutdown
        evaluate: ( Message
            receiver: self
            selector: #oleTRACE:
            arguments: #( 'Smalltalk session terminated' ) ).! !



!VS4WEBComponent methods !
  
acceptErrors
	" Private - Inform the user about error conditions. "

	| result |
	self confirmErrors ifFalse: [ "try to continue anyway"
		self errorDescription: nil.
		self show: self errorDescription.
		^true
	].
	result := true.
	self hasError ifTrue: [
		(MessageBox confirm: 'Has Errors:\'withCrs,self errorDescription,'\Do you want to continue ?'withCrs)
		ifFalse: [ result := false ].
		self errorDescription: nil.
	].
	^result!
 
activexPaneClass
	" Private - returns the current activex pane support class. "

	| default className |
	default := ActivexPane.
	className := self
		propertyAt: #activexPaneClass
		ifAbsent: [ ^default ].
	(className isKindOf: String) ifTrue: [
		^Smalltalk
			at: className asSymbol
			ifAbsent: [ default ]
	].
	^default!
   
activexPaneClass: className
	" Command - Set the activex pane support class for the receiver.
	It MUST be a valid subclass of ActivexPane. "

	self
		propertyAt: #activexPaneClass
		put: className!
 
addErrorDescription: aString
	" Private - Append an error description to current error string. "

    self errorDescription isNil ifTrue: [ ^self errorDescription: aString ].
	self errorDescription: self errorDescription ,'\'withCrs, aString.!
 
allocatedInterfacesDo: aOneArgBlock
    " Private - Enumerate the interfaces supported by the receiver which have been allocated during its lifetime and evaluate <aOneArgBlock> with each. "

    super allocatedInterfacesDo: aOneArgBlock.
    iVS4WEB notNil ifTrue: [ aOneArgBlock value: iVS4WEB ].!
  
argument
    "Returns the instance var of the receiver
     for external manipulation"
    ^argument!

argument: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    argument := anObject!
   
Argument: aString
	" Private - implement the IVS4WEB:Argument property. "

	^self critical: [ self argument: (self asUnicodeParameter: aString) ]!
   
basicInstall: url
	" Command - Download a file from url to instalation[root] directory. "

	^self
		download: url
		to: self rootDirectory
		decompress: false!
   
basicInstallZip: url
	" Command - Download and decompress a file from url to instalation[root] directory. "

	^self
		download: url
		to: self rootDirectory
		decompress: true!
  
bind: aString
	" Set the binding contents.
	Real bindings will occur during evaluation. "

	self bindings: aString!
 
Bind: aString
	" Private - implement the IVS4WEB::Bind property. "

	^self critical: [ self bind: (self asUnicodeParameter: aString) ]!
  
bindings
    "Returns the instance var of the receiver
     for external manipulation"
    ^bindings!

bindings: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    bindings := anObject!
   
checkDirectoryExists: pathName in: aDirectory
	" Private - Check that a directory named pathName exists (or create it). "

	| check fullPath directory |
	check := [:current|
		fullPath := aDirectory drivePathName,'\',current.
		directory := Directory pathName: fullPath.
		directory exists ifFalse: [ directory create ].
	].
	1 to: pathName size - 1 do: [:index|
		(pathName at: index) = $\
		ifTrue: [ check value: (pathName copyForm: 1 to: index -1) ].
	].
	check value: pathName
!
   
closeDialog
	" Private - Close the receiver's dialog"

	dialog isNil ifTrue: [ ^self ].
	dialog close.
	dialog := nil.!

commands
    "Returns the instance var of the receiver
     for external manipulation"
    ^commands!

commands: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    commands := anObject!
   
confirmErrors
	" Private - Returns true when error confirmation dialog must be shown. "

	confirmErrors isNil ifTrue: [ confirmErrors := true ].
	^confirmErrors!
   
critical: aBlock
	" Private - Evaluated aBlock in secure mode.
	Returns anOK OLE result. "

	| stream |
	aBlock on: Error do: [:anError|
		self show: 'Error : ', anError description.
        stream := String new asStream.
        stream nextPutAll: 'Runtime error: ', anError description; cr; cr.
        self walkbackOn: stream maxLevels: 50 stopSelector: nil filtered: false arguments: true.
		Smalltalk isRunTime
		ifTrue: [ Smalltalk logError: stream contents ]
		ifFalse: [ self show: stream contents ].
	].
	^S_OK!
  
decompress: url
	" Command - Download and decompress a file from url to resources directory. "

	^self
		download: url
		to: self resourcesDirectory
		decompress: true!
  
decompress: zipFileName into: aDirectory
	" Private - Decompress a ZIP file into a Directory. "

	| zipSupport zip contents fileNames fileName |
	zipSupport := self zipSupport.
	zipSupport isNil ifTrue: [
		self addErrorDescription: 'Zip support missing.'.
		^false
	].
	[
		zip := zipSupport openRead: zipFileName.
		fileNames := zip fileNames.
		1 to: fileNames size do: [:i|
			fileName := fileNames at: i.
			self dialog notNil
			ifTrue: [
				self dialog
					message: 'Decompressing ',(self shortFileName: fileName);
					percent: i * 100 // fileNames size;
					yourself.
			].
			contents := zip getFileContents: fileName.
			contents notNil ifTrue: [
				(self streamForNewFile: fileName in: aDirectory)
					nextPutAll: contents;
					close.
			].
		].
		zip close.
	] on: Error do: [:ex|
		self addErrorDescription: 'Error decompressing: ',zipFileName,' [',ex description,']'.
		self closeDialog.
		^false
	].
	self closeDialog.
	^true!
 
dialog
    "Returns the instance var of the receiver
     for external manipulation"

	dialog isNil ifTrue: [ self initializeDialog ].
    ^dialog!

Do: aString
	" Private - implement the IVS4WEB::Do operation. "

	^self critical: [ self doCommand: (self asUnicodeParameter: aString) ]!

doBindings
	" Private - Perform bind operations. "

	| aSessionModel firstChar libraries localLibraries |
	self bindings size = 0 ifTrue: [ ^self ].
	" MessageBox message: 'Bind:\'withCrs,self bindings. "
	libraries := self librariesToBindIn: self bindings.
	localLibraries := libraries collect: [:each| self localLibraryFor: each ].
	localLibraries := localLibraries select: [:each| each notNil ].
	localLibraries isEmpty ifTrue: [ ^self ].
	aSessionModel := SessionModel current.
	aSessionModel when: #libraryBound: send: #progress: to: self.
	SmalltalkLibraryBinder groupBind: [
		localLibraries do: [:aLibraryName|
			 (SmalltalkLibraryBinder isBound: aLibraryName)
             ifFalse: [
				self progress: 'Downloading ',(self shortFileName: aLibraryName).
				self show: 'Binding ',aLibraryName asString.
				[
					SmalltalkLibraryBinder bindTo: aLibraryName.
					self show: aLibraryName asString,' bound. [OK]'.
				]
					on: BindError, FileError, ProgressNotification
					do: [ :anException |
						(ProgressNotification handles: anException)
						ifTrue: [ self progress: anException description ]
						ifFalse: [
							 self addErrorDescription: 'Error binding '
								,(self shortFileName: aLibraryName)
								,' (', anException description, ').'
						]
					].
			].
		].
	].
	aSessionModel
        removeActionsWithReceiver: self
        forEvent: #libraryBound:.
	self closeDialog.!

doCommand: aString
	" Set the doCommand property.
	Command will be sent during evaluation.
	aDO command is a command to be sent to the VS4WEB
	 component for mantainment porpouses.
	The format is a multi-line command where the first word
	 is the selector to be applyed to the receiver."

	self commands: aString!
   
doCommands
	" Private - Perform commands.
	aDO command is a command to be sent to the VS4WEB
	 component for mantainment porpouses.
	The format is a multi-line command where the first word
	 is the selector to be applyed to the receiver."

	| aStream command string |
	self commands size = 0 ifTrue: [ ^self ].
	" MessageBox message: 'Do:\'withCrs,self commands. "
	(self linesIn: self commands) do: [:line|
		aStream := ReadStream on: line.
		command := aStream nextWord.
		[
			aStream peek = $:
			ifTrue: [
				aStream next.
				self
					perform: (command,':') asSymbol
					with: (aStream upTo: nil)
			]
			ifFalse: [ self perform: command asSymbol ].
			self show: 'Command {',command asString,'} done.'.
		] on: Error
		do: [:anException|
			self addErrorDescription: 'Command Error {',command asString,'} '
				,anException description
		].
	].
	self acceptErrors.!

dosFileName: fileName
	" Private - Returns a DOS filename from an url filename. "

	^fileName collect: [:c| c = $/ ifTrue: [$\] ifFalse: [c]].!
  
download: url
	" Command - Download a file from url to resources directory. "

	^self
		download: url
		to: self resourcesDirectory
		decompress: false!
  
download: anUrl to: directory decompress: decompress
	" Private - Download a file from url directory. "

	| destination support cantDownload url |

	url := self urlToDownloadFrom: anUrl to: directory.
	url isNil ifTrue: [ ^true ].

	cantDownload := [
		self addErrorDescription: 'Can''t download:',url.
		self closeDialog.
		^false
	].
	destination := directory drivePathName,'/', (self fileNameFromURL: url).
	support := self internetDownloadSupport.
	support isNil ifTrue: [
		self addErrorDescription: 'Internet Download support missing.'.
		^false
	].
	self dialog notNil
	ifTrue: [ self dialog message: 'Downloading ',(self shortFileName: url) ].
	decompress
	ifTrue: [ destination := support urlDownloadToCache: url ]
	ifFalse: [
		(support urlDownload: url toFile: destination)
		ifFalse: [ cantDownload value. ].
		^true
	].
	destination isNil ifTrue: [ cantDownload value ].
	self closeDialog.
	^self decompress: destination into: directory!

errorDescription
    "Returns the instance var of the receiver
     for external manipulation"
    ^errorDescription!

errorDescription: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    errorDescription := anObject!
   
evaluate
	" Perform evaluate operation.
	The receiver can be:
		empty for nil
		'self' for the VS4WEBComponent
		a Global Name (in Smalltalk).
	The selector can be:
		empty for no evaluation
		a simple selector to be sent to the receiver with no arguments
		a one-argument selector (the VS4WEB component will be passed to the receiver)
		a two-argument selector for passing the VS4WEBComponent and the aditional argument (aString)
	The argument must be a string and will be passed as second argument.
	"

	| aReceiver aSelector arguments argCount |

	self prepareToBeEvaluated.

	self acceptErrors ifFalse: [ ^nil ].
	selector size = 0 ifTrue: [ ^self ].
	aReceiver := receiver size = 0 ifTrue: [ nil ]
		ifFalse: [
			receiver = 'self' ifTrue: [ self ]
			ifFalse: [ "Bound to a global name."
				Smalltalk
					at: receiver asSymbol
					ifAbsent: [ self addErrorDescription: 'Name not found: ',receiver.nil]
			]
		].
	aSelector := selector asSymbol.
	argCount := Message numberOfArgumentsFor: aSelector.
	arguments := argCount = 0 ifTrue: [ Array new ]
		ifFalse: [
			argCount = 1 ifTrue: [ Array with: self ]
			ifFalse: [ Array with: self with: self argument ]
		].

	[
		self show: 'Starting evaluation : '
			,receiver asString
			,' #',selector asString
			,' with ', arguments asString.

		aReceiver perform: aSelector withArguments: arguments
	]
	on: Error
	do: [:anException|
		self addErrorDescription: 'Error during evaluation '
			,anException description
	].
	self acceptErrors.
"
	(Message
		receiver: aReceiver
		selector: aSelector
		arguments: arguments
		) performDeferred.
"!
 
Evaluate
	" Private - implement the IVS4WEB::Evaluate operation. "

	^self critical: [ self evaluate ]!
  
exitIfNotInUse
	" Command - Set the receiver to exit as soon as posible (default action). "

	OLEClassFactoryObject exitIfNotInUse: true.!
   
fileNameFromURL: url
	" Private - Returns a file name from an URL.
	Only the filename without path will be returned."

	^(self dosFileName: url) fileNameLessPath!
  
findFileName: fileName
	" Private - Returns the fileName of a file matching fileName in the lookup paths. "

	| result |
	(Array
		with: self libraryDirectory drivePathName
		with: self resourcesDirectory drivePathName
		with: nil "default path")
	do: [:path|
		result := File findFileName: fileName on: path.
		result notNil ifTrue: [ ^result ].
	].
	^nil!
   
getInterfaceForIID: iid
    " Private - Answer the interface identified by the GUID <iid>.
    Answer nil if the requested interface is not supported by the receiver. "

	self show: 'VS4WEBAutomationServer>>#getInterfaceForIID:',iid asString.

    iid = iVS4WEB iid ifTrue: [
        " preallocated interfaces which are always constructed are simply returned "
        ^iVS4WEB
    ].
    ^super getInterfaceForIID: iid!
  
hasError
	" True if the receiver has detected an error. "

	^self errorDescription notNil!
   
hideErrors
	" Command - Set the receiver to NOT prompt continuations on error. "

	confirmErrors := false.!
  
hideProgressDialogs
	" Command - Set the receiver to NOT show progress dialogs. "

	useProgressDialogs := false.
	self closeDialog.!

initializeDialog
	" Private - Initializes the receiver's dialog if we are using dialogs. "

	self useProgressDialogs ifFalse: [ ^dialog := nil ].

	dialog := ProgressIndicatorDialog new
		noCancel ;
		open: self class name message: String new;
		showPercent;
		yourself.
    ^dialog!
   
initializeInterfaces
    " Private - Allocate any interfaces which are expected to be required during the object's lifetime.
    Invoke the superclass method to ensure that the inner IUnknown is allocated. "

	self show: 'VS4WEBAutomationServer>>#initializeInterfaces [start]'.

    super initializeInterfaces.

    "  Pre-allocation of supported interfaces at object creation time is done by reimplementing this method.
        Allocation during initialization is a good strategy for interfaces which are known to be required during the object's lifetime.
        Interfaces which may not be requested can be supported by a lazy allocation strategy, typically implemented in #getInterfaceForIID:
    "
    iVS4WEB := IVS4WEB on: self.

	self show: 'VS4WEBAutomationServer>>#initializeInterfaces [done]'.!
 
install: url
	" Command - Download a file from url to library directory. "

	^self
		download: url
		to: self libraryDirectory
		decompress: false!
   
installZip: url
	" Command - Download and decompress a file from url to library directory. "

	^self
		download: url
		to: self libraryDirectory
		decompress: true!
  
internetDownloadSupport
	" Private - Returns the Internet dounload component. "

	| urlMonDLL |
	urlMonDLL := Smalltalk at: #URLMonDLL ifAbsent: [ ^nil ].
	^urlMonDLL current!

isLibraryPackage: pathName
	" Private - Returns true if pathName is a valid library package.
	The library packages has .ZLL or .ZIP extensions.
	"

	| dosFileName |
	dosFileName := self dosFileName: pathName.
	^#( 'zll' 'zip' ) includes: dosFileName fileExtension asLowerCase!
 
isURL: aName
	" Private - Returns true if aName is considered an internet URL. "

	^#('http' 'ftp' 'gopher') includes: (aName upTo: $:) asLowerCase!
 
librariesToBindIn: aString
	" Private - Returns the library names for libraries to be bound.
	Library names can be remote and in .bnd format (no @ supported... yet)."

	| lines |
	lines := OrderedCollection new.
	(self linesIn: aString) do: [:line|
		line first = $@ ifTrue: [
			self addErrorDescription: 'Bindings can''t have includes.'
				,' Please remove from bindings the line: ',line.
		] ifFalse: [ lines add: line ].
	].
	^lines!
  
libraryDirectory
	" Private - Returns the library directory. "

	^self rootDirectory

	" We do NOT use .\Lib because it will force us to add it to the system path
	| directory |
	directory := Directory pathName: 'Lib'.
	directory exists ifFalse: [ directory create ].
	^directory
	"!
   
linesIn: aString
	" Private - Returns the lines identified in aString (in .bnd format)."

	| stream result firstChar aLine nextLine line |
	result := OrderedCollection new.
	stream := ReadStream on: aString.
	nextLine := [ "HTML file use to have only CR and no LF"
		line := stream upTo: Cr.
		stream peek == Lf ifTrue: [ stream next ].
		line
	].
	[stream atEnd] whileFalse: [
		firstChar := stream peek.
		firstChar = $; ifTrue: [ nextLine value ]
		ifFalse: [
			aLine := (nextLine value upTo: $;) trimBlanks.
			aLine notEmpty ifTrue: [ result add: aLine ].
		].
	].
	^result!
 
localLibraryFor: aName
	" Private - Returns the fileName of a local file for library named aName.
	A local copy for library named aName will be done (if needed). "

	| sllFileName |
	sllFileName:= (self isURL: aName)
		ifTrue: [ self localLibraryForURL: aName ]
		ifFalse: [ aName ].
	sllFileName isNil ifTrue: [^nil].
	sllFileName := sllFileName fileExtension asLowerCase = 'sll'
		ifTrue: [sllFileName] ifFalse: [ aName,'.SLL'].

	(File findFileName: sllFileName on: nil) isNil
	ifTrue: [ "library has NOT been found in path"
		self show: 'Library not found ',sllFileName.
		^nil
	].
	^sllFileName fileNameLessPath!
  
localLibraryForURL: url
	" Private - Returns the fileName of a local file for library downloaded from url.
	The url can point to:
		a library at  ...url...[.SLL]
		a library pack at url.[ZLL | ZIP]
	In case of a ZLL (or ZIP) library pack a nil will be returned as a local library name.
	"

	(self isLibraryPackage: url)
	ifTrue: [
		self installZip: url.
		^nil "no more instalation required"
	].

	"install an SLL copying from server."
	self install: url.
	^self localLibraryFor: (self dosFileName: url) fileNameLessPath!
  
OnChar: char count: count flags: flags
	" Private - implement the IVS4WEB::OnChar operation. "

	^self critical: [ self onChar: char count: count flags: flags ]!

onChar: char count: count flags: flags
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onChar: char count: count flags: flags
	].!
 
onDraw: pDc bounds: bounds invalid: invalid
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onDraw: pDc bounds: bounds invalid: invalid
	].!
   
OnDraw: pDc bounds: bounds invalid: invalid
	" Private - implement the IVS4WEB::OnDraw operation. "

	^self critical: [ self onDraw: pDc bounds: bounds invalid: invalid ]!
  
onEraseBkgnd: pDc
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onEraseBkgnd: pDc
	].!
   
OnEraseBkgnd: pDc
	" Private - implement the IVS4WEB::OnEraseBkgnd operation. "

	^self critical: [ self onEraseBkgnd: pDc ]!

onKeyDown: char count: count flags: flags
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onKeyDown: char count: count flags: flags
	].!
   
OnKeyDown: char count: count flags: flags
	" Private - implement the IVS4WEB::OnKeyDown operation. "

	^self critical: [ self onKeyDown: char count: count flags: flags ]!
   
OnKeyUp: char count: count flags: flags
	" Private - implement the IVS4WEB::OnKeyUp operation. "

	^self critical: [ self onKeyUp: char count: count flags: flags ]!
 
onKeyUp: char count: count flags: flags
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onKeyUp: char count: count flags: flags
	].!
   
OnLButtonDblClk: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnLButtonDblClk operation. "

	^self critical: [ self onLButtonDblClk: nFlags x: x y: y ]!
 
onLButtonDblClk: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onLButtonDblClk: nFlags x: x y: y
	].!
   
onLButtonDown: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onLButtonDown: nFlags x: x y: y
	].!
   
OnLButtonDown: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnLButtonDown operation. "

	^self critical: [ self onLButtonDown: nFlags x: x y: y ]!
   
onLButtonUp: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onLButtonUp: nFlags x: x y: y
	].!
   
OnLButtonUp: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnLButtonUp operation. "

	^self critical: [ self onLButtonUp: nFlags x: x y: y ]!
 
onMButtonDblClk: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onMButtonDblClk: nFlags x: x y: y
	].!
   
OnMButtonDblClk: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnMButtonDblClk operation. "

	^self critical: [ self onMButtonDblClk: nFlags x: x y: y ]!
 
OnMButtonDown: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnMButtonDown operation. "

	^self critical: [ self onMButtonDown: nFlags x: x y: y ]!
   
onMButtonDown: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onMButtonDown: nFlags x: x y: y
	].!
   
onMButtonUp: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onMButtonUp: nFlags x: x y: y
	].!
   
OnMButtonUp: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnMButtonUp operation. "

	^self critical: [ self onMButtonUp: nFlags x: x y: y ]!
 
onMouseMove: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onMouseMove: nFlags x: x y: y
	].!
   
OnMouseMove: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnMouseMove operation. "

	^self critical: [ self onMouseMove: nFlags x: x y: y ]!
 
onRButtonDblClk: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onRButtonDblClk: nFlags x: x y: y
	].!
   
OnRButtonDblClk: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnRButtonDblClk operation. "

	^self critical: [ self onRButtonDblClk: nFlags x: x y: y ]!
 
OnRButtonDown: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnRButtonDown operation. "

	^self critical: [ self onRButtonDown: nFlags x: x y: y ]!
   
onRButtonDown: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onRButtonDown: nFlags x: x y: y
	].!
   
onRButtonUp: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onRButtonUp: nFlags x: x y: y
	].!
   
OnRButtonUp: nFlags x: x y: y
	" Private - implement the IVS4WEB::OnRButtonUp operation. "

	^self critical: [ self onRButtonUp: nFlags x: x y: y ]!
 
onTimer: nIDEvent
    " Private - Processes message sent to the control window. "

    self window notNil ifTrue: [
		self window onTimer: nIDEvent
	].!
   
OnTimer: nIDEvent
	" Private - implement the IVS4WEB::OnTimer operation. "

	^self critical: [ self onTimer: nIDEvent ]!
 
prepareToBeEvaluated
	" Private - Prepare the receiver to be evaluated.
	Here we will perform component setUp ad library bindings.
	"

	"first evaluate adminiatrative commands, then load bindings."
	[ self doCommands ] on: Error do: [:anException|
			self addErrorDescription: 'Error during DO evaluation '
				,anException description
		].
	[ self doBindings ] on: Error do: [:anException|
			self addErrorDescription: 'Error during binding '
				,anException description
		].
	^self acceptErrors!

progress: aLibOrNameOrPercent
    "Private - Provide bind progress feedback."

    | s |
    dialog isNil ifTrue: [ ^self ].
    s := aLibOrNameOrPercent.
    s isNumber ifTrue: [ dialog showPercent. ^dialog percent: s ].
    s isString ifFalse: [ s := s name ].
    dialog message: s.!
  
receiver
    "Returns the instance var of the receiver
     for external manipulation"
    ^receiver!

receiver: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    receiver := anObject!
   
Receiver: aString
	" Private - implement the IVS4WEB::Receiver operation. "

	^self critical: [ self receiver: (self asUnicodeParameter: aString) ]!
 
resetAllocatedInterfaces
    " Private - reset the references to the interfaces supported by the receiver. "

    super resetAllocatedInterfaces.
    iVS4WEB := nil.!
  
resourcesDirectory
	" Private - Returns the resources directory. "

	| directory |
	directory := Directory pathName: 'Resources'.
	directory exists ifFalse: [ directory create ].
	^directory!
   
rootDirectory
	" Private - Returns the instalation[root] directory. "

	^Directory pathName: String new!
 
selector
    "Returns the instance var of the receiver
     for external manipulation"
    ^selector!

Selector: aString
	" Private - implement the IVS4WEB::Selector operation. "

	^self critical: [ self selector: (self asUnicodeParameter: aString) ]!
 
selector: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    selector := anObject!
   
shortFileName: fileName
	" Private - Returns a short file name from fileName (extracts path). "

	^((fileName reversed
		upTo: $\) upTo: $/)
		reversed!
   
show: aString
	"Dump aString onto the notifier."

	^self class notify: aString.!
 
showErrors
	" Command - Set the receiver to prompt continuations on error. "

	confirmErrors := true.!
   
showProgressDialogs
	" Command - Set the receiver to shown progress dialogs. "

	useProgressDialogs := true.!

stayResident
	" Command - Set the receiver to be resident in memory until explisit exit. "

	OLEClassFactoryObject exitIfNotInUse: false.!
   
streamForNewFile: fileName in: aDirectory
	" Private - Returns a write stream for file names fileName relative to aDirectory. "

	| stream dosFileName |
	dosFileName := self dosFileName: fileName.
	self checkDirectoryExists: dosFileName fileNamePath in: aDirectory.
	^File newFile: aDirectory drivePathName,'\',dosFileName!
   
urlToDownloadFrom: anUrl to: directory
	" Private - Returns the real URL to download.
	 We accept here a simple URL or a fileName a $| separator and a normal URL
	The url will be returned if the file (fileName) does NOT exist in directory.
	Else nil will be returned.
	This can be used to avoid multiple downloads when a file is yet installed.
	"

	| parts fileName files |
	parts := anUrl asArrayOfSubstringsSeparatedBy: $|.
	parts := parts collect: [:each| each trimBlanks ].
	parts isEmpty ifTrue: [ ^nil ].
	parts size > 1
	ifTrue: [
		files := directory fileNames collect: [:each| each asLowercase ].
		 1 to: parts size - 1 do: [:i|
			(files includes: (parts at: i) asLowercase)
			ifFalse: [
				"
				MessageBox message: 'File not found ',(parts at: i)
					,'\in\'withCrs,files asArray asString.
				"
				^parts last
			].
		].
		^nil "all files are present, we must not install"
	].
	^parts last!
 
useProgressDialogs
	" Private - Returns true when progress dialogs must be shown. "

	useProgressDialogs isNil ifTrue: [ useProgressDialogs := true ].
	^useProgressDialogs!

window
    "Returns the instance var of the receiver
     for external manipulation"
    ^window!

WindowHandle: anInteger
	" Private - implement the IVS4WEB::WindowHandle operation. "

	^self critical: [ self windowHandle: anInteger ]!

windowHandle: anInteger
	" Set the windowHandle of the receiver. "

	| aWindowHandle obsolete |
	anInteger = 0 | anInteger isNil
	ifTrue: [
		self show: 'Closing ActivexPane.'.
		obsolete := window.
		window := nil.
		obsolete notNil ifTrue: [ obsolete close ].
		^self
	].
	aWindowHandle := WindowHandle fromInteger: anInteger.
	(window notNil and: [window handle = aWindowHandle]) ifTrue: [ ^self ].

	self show: 'Creating window ',aWindowHandle asString.
	window := ActivexPane new.
	window createWith: aWindowHandle.
	self show: 'ActivexPane created; isValid: ',window isValid asString.

	self evaluate.

	"Force window contents to be filled when window open
		and resource script evaluated."
    window
		triggerEvent: #needsContents;
		event: #getContents.!
   
zipSupport
	" Private - Returns the zip decompression component (or nil if uninstalled). "

	^Smalltalk at: #ZipLibrary ifAbsent: []! !



!VS4WEBAutomationServer class methods !
   
clsid
        " Answer the CLSID of instances of the receiver. "

    " '{08B9DF83-CF53-11D2-9452-000001252013}' asGUID "
    ^GUID fromBytes: #[ 16r83 16rDF 16rB9 8 16r53 16rCF 16rD2 16r11 16r94 16r52 0 0 1 16r25 16r20 16r13 ]!

constructDispatchSpecificationsWithKey: aSymbol
    " Answer the dispatch specification table describing the methods and properties
        supported through OLE automation by the VS4WEBComponent. "

    ^self newDispatchSpecificationTable
        specificationKey: aSymbol;
        decodeSpecificationsFromLiteralArray: self methodSpecificationsLiteral;
        decodeSpecificationsFromLiteralArray: self propertySpecificationsLiteral;
        yourself!
  
constructMethodSpecificationsWithKey: aSymbol
        " Answer the dispatch specification table describing the methods
        supported through OLE automation by the VS4WEBComponent. "

    ^self newDispatchSpecificationTable
        specificationKey: aSymbol;
        decodeSpecificationsFromLiteralArray: self methodSpecificationsLiteral;
        yourself!
  
constructPropertySpecificationsWithKey: aSymbol
        " Answer the dispatch specification table describing the properties
        supported through OLE automation by the VS4WEBComponent. "

    ^self newDispatchSpecificationTable
        specificationKey: aSymbol;
        decodeSpecificationsFromLiteralArray: self propertySpecificationsLiteral;
        yourself!
   
createController
    " Create a new automation object and answer an automation controller dispatch driver on it. "

    | aDispatcher errorMessage |
    aDispatcher := [ self createControllerInServerProcess ]
        on: OLEError
        do: [ :ex | errorMessage := ex description. ex return: nil ].
    aDispatcher isNil
    ifTrue: [
        MessageBox message:
                'Unable to create a ',self name,' object \('withCrs,errorMessage,
                ').\  You need to create and register the object server application. 'withCrs
    ].
    ^aDispatcher!
   
createControllerInServerProcess
    " Create a new VS4WEBAutomationServer and answer an automation controller dispatch driver on it."

    | anIDispatch |
    anIDispatch := IClassFactory createInstance: self clsid iid: IID_IDispatch.
    ^OLEDispatchDriver on: anIDispatch specificationTable: self dispatchSpecifications !

current
    "Returns the last instance of the receiver created (or nil)."

    ^current!
 
current: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    current := anObject!
 
dispatchSpecifications
    " Answer the dispatch specification table for accessing instances
      of the receiver though an OLE automation controller dispatch driver. "

    " self dispatchSpecifications "
    " OLEDispatchAnalyzer describeSpecificationTable: self dispatchSpecifications "
    ^self constructDispatchSpecificationsWithKey: #name!
   
dispatchSpecificationsForServer
    " Answer the dispatch specification table for publishing instances
      of the receiver though an OLE automation controller dispatch driver. "

    " self dispatchSpecificationsForServer "
    ^(self constructDispatchSpecificationsWithKey: #memberID) clsid: self clsid; yourself!
   
generateDispatchSpecifications
    "Create the report for all dispatch specifications in the type library. "

    " VS4WEBAutomationServer generateDispatchSpecifications "

    | anITypeLib |
    anITypeLib := self getTypeLibrary.
    [ OLEDispatchAnalyzer generateTypeLibrarySpecifications: anITypeLib ] ensure: [ anITypeLib release ].!

getTypeLibrary
    "Answer the ITypeLib associated with the receiver."

    " VS4WEBAutomationServer getTypeLibrary "
    ^ITypeLib
        registeredID: self typeLibraryID
        lcid: self typeLibraryLCID!
  
iidIVS4WEBDescription
    " Answer a description of the the dispatch interface with which a VS4WEBAutomationServer
    is published as an OLE automation object. "

    ^'IVS4WEBDisp'!
 
iidIVS4WEBDisp
        " Answer the IID of the receiver's dispatch interface specifications
        in its type library for the IVS4WEB methods and properties. "

    " '{08B9DF85-CF53-11D2-9452-000001252013}' asGUID "
    ^GUID fromBytes: #[ 16r85 16rDF 16rB9 8 16r53 16rCF 16rD2 16r11 16r94 16r52 0 0 1 16r25 16r20 16r13 ]!
  
installComponent
    " Install the VS4WEBAutomationServer. "

    SessionModel current isRunTime
        ifTrue: [
            SessionModel current
                when: #startUpApplication
                send: #startUpApplication to: self ].!
 
methodDispatchSpecifications
        " Answer the method dispatch specification table for accessing instances
        of the receiver though an OLE automation controller dispatch driver. "

    ^self constructMethodSpecificationsWithKey: #name!

methodSpecificationsLiteral
        " Answer the literal definition of the dispatch specification describing the methods
        supported through OLE automation by the VS4WEBAutomationServer. "

    ^#(
        "#OLEDispatchSpecificationTable
        #specificationKey: #name"

        #( 'method' 'Evaluate' 200
            #typeCode: #VT_VOID
            #selector: #evaluate
            )

        #( 'method' 'OnDraw' 201
            #typeCode: #VT_VOID
            #selector: #onDraw:bounds:invalid:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnEraseBkgnd' 202
            #typeCode: #VT_VOID
            #selector: #onEraseBkgnd:
			#parameterTypes: #( #VT_I4 )
            )

        #( 'method' 'OnChar' 203
            #typeCode: #VT_VOID
            #selector: #onChar:count:flags:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnKeyDown' 204
            #typeCode: #VT_VOID
            #selector: #onKeyDown:count:flags:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnKeyUp' 205
            #typeCode: #VT_VOID
            #selector: #onKeyUp:count:flags:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnLButtonDblClk' 206
            #typeCode: #VT_VOID
            #selector: #onLButtonDblClk:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnLButtonDown' 207
            #typeCode: #VT_VOID
            #selector: #onLButtonDown:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnLButtonUp' 208
            #typeCode: #VT_VOID
            #selector: #onLButtonUp:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnMButtonDblClk' 209
            #typeCode: #VT_VOID
            #selector: #onMButtonDblClk:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnMButtonDown' 210
            #typeCode: #VT_VOID
            #selector: #onMButtonDown:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnMButtonUp' 211
            #typeCode: #VT_VOID
            #selector: #onMButtonUp:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnMouseMove' 212
            #typeCode: #VT_VOID
            #selector: #onMouseMove:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnRButtonDown' 213
            #typeCode: #VT_VOID
            #selector: #onRButtonDown:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnRButtonUp' 214
            #typeCode: #VT_VOID
            #selector: #onRButtonUp:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnRButtonDblClk' 215
            #typeCode: #VT_VOID
            #selector: #onRButtonDblClk:x:y:
			#parameterTypes: #( #VT_I4 #VT_I4 #VT_I4 )
            )

        #( 'method' 'OnTimer' 216
            #typeCode: #VT_VOID
            #selector: #onTimer:
			#parameterTypes: #( #VT_I4 )
            )

        )!
  
new
	" Answer a new instance of the receiver. "

	"Test the proper initialization of IIDs when creating an instance."
	self testIIDs.

	^super new!
   
newDispatchSpecificationTable
        " Private - answer a new empty dispatch specification table
        for publishing or controlling instances of the receiver. "

    ^OLEDispatchSpecificationTable new
        iid: self iidIVS4WEBDisp;
        name: self iidIVS4WEBDescription;
        yourself!
   
propertyDispatchSpecifications
        " Answer the property dispatch specification table for accessing instances
        of the receiver though an OLE automation controller dispatch driver. "

    ^self constructPropertySpecificationsWithKey: #name!
  
propertySpecificationsLiteral
        " Answer the literal definition of the dispatch specification describing the properties
        supported through OLE automation by the OLERandomNumberGenerator. "

    ^#(
        "#OLEDispatchSpecificationTable
        #specificationKey: #name"

        #( 'property' 'WindowHandle' 100
            #typeCode: #VT_I4
            #setSelector: #windowHandle:
            )
        #( 'property' 'Receiver' 101
            #typeCode: #VT_BSTR
            #setSelector: #receiver:
            )
        #( 'property' 'Selector' 102
            #typeCode: #VT_BSTR
            #setSelector: #selector:
            )
        #( 'property' 'Argument' 103
            #typeCode: #VT_BSTR
            #setSelector: #argument:
            )
        #( 'property' 'Do' 104
            #typeCode: #VT_BSTR
            #setSelector: #doCommand:
            )
        #( 'property' 'Bindings' 105
            #typeCode: #VT_BSTR
            #setSelector: #bind:
            )
        )!
   
registerClassFactory
        " Register a class factory to create instances of the receiver.
        Answer the class factory. "

    | aClassFactory |
    aClassFactory := self newClassFactory.
    [ aClassFactory registerAsMultipleUseLocalServer ]
    on: OLEError do: [ :ex |
		self show: 'VS4WEBAutomationServer class>>#registerClassFactory [failure]=',ex description asString.
		^nil
	].
	self show: 'VS4WEBAutomationServer class>>#registerClassFactory [ok]=',aClassFactory asString.
    ^aClassFactory!

registerIIDs
	" Register IIDs needed for proper server startUp.
		VS4WEBAutomationServer registerIIDs.
	"

	| dispIID |
    dispIID := self iidIVS4WEBDisp.
    IVS4WEB iid: dispIID; registerIID.
    IVS4WEBPointer iid: dispIID; registerIID.

    IVS4WEBImplementation iid: dispIID.
    IVS4WEBImplementation initialize.

	IVS4WEBImplementation vtable isNil
	ifTrue: [
		self error: 'Invalid IVS4WEBImplementation vtable.'
	].
!

startUpApplication
    " Start up the OLE automation object server application "

	self show: 'VS4WEBAutomationServer class>>#startUpApplication'.

    " initialize OLE and verify that the application is being run as an object server "
    OLESessionManager isOLEAvailable
    ifFalse: [
		self show: 'Unable to initialize OLE object server application (OLE support is not available).'.
        OLESessionManager terminateServerSession:
            'Unable to initialize OLE object server application (OLE support is not available).'
    ].
    OLESessionManager sessionStartedToServiceObjects
    ifFalse: [
		self show: 'Command line did not include \Embedding flag.'.
        OLESessionManager terminateServerSession:
            'Command line did not include \Embedding flag.'
    ].

    " register the class factory for the object server application "
    self registerClassFactory isNil
    ifTrue: [
		self show: 'Class factory registration for ', self name, ' failed.'.
        OLESessionManager terminateServerSession:
            'Class factory registration for ', self name, ' failed.'
    ].

    " arrange for server application termination "
    OLEClassFactoryObject exitIfNotInUse: true.

	self show: 'VS4WEBAutomationServer class>>#startUpApplication terminated'.!

testIIDs
	" Test IIDs needed for proper server startUp.
		VS4WEBAutomationServer testIIDs.
	"

	IVS4WEB iid isNil ifTrue: [
		self registerIIDs
	].!
 
typeLibraryID
    " Answer the IID of the receiver's type library (VS4WEB.TLB). "

    " '{08B9DF84-CF53-11D2-9452-000001252013}' asGUID "
    ^GUID fromBytes: #[ 16r84 16rDF 16rB9 8 16r53 16rCF 16rD2 16r11 16r94 16r52 0 0 1 16r25 16r20 16r13 ]!
   
typeLibraryLCID
    " Answer the LCID for the type library for the specifications."

    ^1033    " = 16r409 "! !



!VS4WEBAutomationServer methods !
   
automationServer
        " Private - answer the OLEAutomationServer which dispatches
        incoming automation invocations to the receiver. "

    ^automationServer!
 
automationServer: anAutomationServer
        " Private - set the OLEAutomationServer which dispatches
        incoming automation invocations to the receiver. "

    automationServer := anAutomationServer.!
  
createAutomationServer
        " Private - answer the inner IUnknown of an automation server object
        which will be contained within this aggregate object so that its
        IDispatch interface can be exposed by the aggregate. "

    | automationServerObject |

	self show: 'VS4WEBAutomationServer>>#createAutomationServer'.

    automationServerObject := ( OLEAutomationServer forControllingUnknown: self controllingUnknown )
        publishedObject: self;
        specificationTable: self class dispatchSpecificationsForServer;
        yourself.

    " explicitly reference count the inner object which we reuse as an aggregate "
        " Implementation note: we need to increment the aggregated object's
        reference count here when directly instantiating a locally-implemented
        object.  This is not necessary when the inner object is created
        using its class factory, which by definition always returns a separately
        reference counted inner IUnknown to the creator. "
    ^automationServerObject innerUnknown separateReference!
   
initialize
        " Private - initialize a new instance. "

	self show: 'VS4WEBAutomationServer>>#initialize'.
	self class current: self.
    super initialize.

    " create inner objects used to implement the receiver as an aggregate "
    self automationServer: self createAutomationServer.!
  
innerQueryInterface: iid _: resultReference
        " Private - implement the non-delegating IUnknown::QueryInterface function.
        Query the receiver for the interface identified by the GUID <iid>.
        If the requested interface is supported by the receiver, store
        a new reference counted copy of the interface into <resultReference>.
        Answer the result code. "

	self show: 'VS4WEBAutomationServer>>#innerQueryInterface:_:'.

    " Note that the controlling object of an aggregate which directly
        exposes interfaces of an contained object must query the
        inner IUnknown of the aggregated object by reimplementing
        this method.  In contrast, recall that the usual implementation
        of QueryInterface support for interfaces implemented directly
        by the receiver is done by reimplementing #getInterfaceForIID:.
        If aggregated objects are queried there, however, double
        reference counting on the controlling object will result.
        Consequently, the controlling object of an aggregate may
        implement its QueryInterface support in two places:
        - here in #innerQueryInterface:_: for any interfaces
            of contained objects which are directly exposed to clients
        - in the usual #getInterfaceForIID: for any interfaces
            implemented directly by the controlling object. "
    iid = IID_IDispatch
        ifTrue: [ ^self automationServer interfaceBinding QueryInterface: IID_IDispatch _: resultReference ].
    ^super innerQueryInterface: iid _: resultReference!
   
releaseAutomationServer
        " Private - release the automation server object which publishes the receiver. "

    automationServer notNil
        ifTrue: [  " release the inner object carefully to avoid any release cycles "
            | innerObject |
            innerObject := automationServer.
            automationServer := nil.
            "self ASSERT: innerObject localImplementor referenceCount = 1."
            innerObject release ].!
  
releaseInnerObjects
        " Private - release any inner objects owned by the receiver. "

    self releaseAutomationServer.! !



!IVS4WEB methods !
   
argument: aString
	" Set the argument to aString. "

	^interface Argument: aString!
  
bind: aString
	" Set the bindings to aString. "

	^interface Bind: aString!
  
callbackAddress
	"Returns the callback."

	| resultReference |
	resultReference := nil asValueReference.
	interface Callback: resultReference.
	^resultReference value!
   
doCommand: aString
	" Set the doCommand to aString. "

	^interface Do: aString!
  
evaluate
	"Evaluate with current settings."

	^interface Evaluate!
   
onChar: char count: count flags: flags
    "Process message sent to the control window. "

	^interface OnChar: char count: count flags: flags!
   
onDraw: pDc bounds: bounds invalid: invalid
    "Process message sent to the control window. "

	^interface OnDraw: pDc bounds: bounds invalid: invalid!
 
onEraseBkgnd: pDc
    "Process message sent to the control window. "

	^interface OnEraseBkgnd: pDc!
 
onKeyDown: char count: count flags: flags
    "Process message sent to the control window. "

	^interface OnKeyDown: char count: count flags: flags!
 
onKeyUp: char count: count flags: flags
    "Process message sent to the control window. "

	^interface OnKeyUp: char count: count flags: flags!
 
onLButtonDblClk: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnLButtonDblClk: nFlags x: x y: y!
 
onLButtonDown: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnLButtonDown: nFlags x: x y: y!
 
onLButtonUp: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnLButtonUp: nFlags x: x y: y!
 
onMButtonDblClk: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnMButtonDblClk: nFlags x: x y: y!
 
onMButtonDown: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnMButtonDown: nFlags x: x y: y!
 
onMButtonUp: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnMButtonUp: nFlags x: x y: y!
 
onMouseMove: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnMouseMove: nFlags x: x y: y!
 
onRButtonDblClk: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnRButtonDblClk: nFlags x: x y: y!
 
onRButtonDown: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnRButtonDown: nFlags x: x y: y!
 
onRButtonUp: nFlags x: x y: y
    "Process message sent to the control window. "

	^interface OnRButtonUp: nFlags x: x y: y!
 
onTimer: nIDEvent
    "Process message sent to the control window. "

	^interface OnTimer: nIDEvent!
 
receiver: aString
	" Set the receiver to aString. "

	^interface Receiver: aString!
  
selector: aString
	" Set the selector to aString. "

	^interface Selector: aString!
  
windowHandle: anInteger
	" Set the window handle. "

	^interface WindowHandle: anInteger! !



!IVS4WEBPointer methods !
 
Evaluate
		" Invoke the IVS4WEB::Evaluate function.
		Raise an exception if an error occurs.  Answer the result code. "

	^self invokeEvaluate!
 
invokeEvaluate
	" Private - invoke the IVS4WEB::Evaluate function. "

	" HRESULT Evaluate(void); "

    <ole: 3 hresult>
    ^self vtableDispatchFailed! !



!ActivexPane class methods !

constructEventsTriggered
	"Private - Answer the set of events that instances of the receiver can trigger."

    ^super constructEventsTriggered
        add: #created ;
        add: #display ;
        add: #eraseBackground ;
        add: #resized ;
        add: #timer: ;
        add: #button1Down ;
        add: #button1DownShift ;
        add: #button1Moved ;
        add: #button1UpShift ;
        add: #button2DoubleClicked ;
        add: #button2Down ;
        add: #button2Moved ;
        add: #clicked: ;
        add: #doubleClicked ;
        add: #closed ;
        yourself! !



!ActivexPane methods !

button1DoubleClick: aPoint
        "Private - button 1 has been double clicked.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button1DoubleClick.
    self triggerEvent: #doubleClicked!
 
button1Down: aPoint
        "Private - Left button has been pressed down.
        Let the owner process the event."
    (super button1Down: aPoint) ifFalse: [^ self].
    self captureMouseInput.
    mouse := aPoint.
    self event: #button1Down.
    self triggerEvent: #button1Down.!
  
button1DownShift: aPoint
        "Private - Left button and shift key are both down.
        Let the owner process the event."
    self captureMouseInput.
    mouse := aPoint.
    self event: #button1DownShift.
    self triggerEvent: #button1DownShift!
  
button1Move: aPoint
        "Private - button 1 is down and the
        mouse has been moved.
        Let the owner process the event."
    self isDragSource ifTrue: [ ^super button1Move: aPoint ].
	"
    handle = WindowHandle queryCapture ifFalse: [ ^self ].
	"
    mouse := aPoint.
    self event: #button1Move.
    self triggerEvent: #button1Moved!
   
button1Up: aPoint
        "Private - Left button has been released.
        Let the owner process the event."

    super button1Up: aPoint.
	" handle = WindowHandle queryCapture ifFalse: [ ^self ]. "
    self clearMouseCapture.
    mouse := aPoint.
    self event: #button1Up.
    self triggerEvent: #clicked: with: aPoint.!
   
button1UpShift: aPoint
        "Private - Button 1 has been released with shift key down.
        Let the owner process the event."

    super button1UpShift: aPoint.
	"handle = WindowHandle queryCapture ifFalse: [ ^self ]."
    self clearMouseCapture.
    mouse := aPoint.
    self event: #button1UpShift.
    self triggerEvent: #button1UpShift!
 
button2DoubleClick: aPoint
        "Private - button 2 has been double clicked.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button2DoubleClick.
    self triggerEvent: #button2DoubleClicked!
  
button2Down: aPoint
        "Private - button 2 has been pressed down.
        Let the owner process the event
        or do the right button scrolling."
    mouse := aPoint.
    ( ( self handlesEvent: #button2Down )
    or: [ self hasActionForEvent: #button2Down ] )
        ifTrue: [
            self event: #button2Down.
            self triggerEvent: #button2Down ]
        ifFalse: [ super button2Down: aPoint ]!
 
button2Move: aPoint
        "Private - button 2 is down and the
        mouse has been moved.
        Let the owner process the event."
    self isLocalDragSource ifTrue: [ ^super button2Move: aPoint ].

    mouse := aPoint.
    self event: #button2Move.
    self triggerEvent: #button2Moved!

button2Up: aPoint
        "Private - button 2 has been released.
        Let the owner process the event or
        finish the right button scrolling."
    mouse := aPoint.
    self clearMouseCapture.
    ( ( self handlesEvent: #button2Up )
    or: [ self hasActionForEvent: #rightClicked ] )
        ifTrue: [
            self event: #button2Up.
            self triggerEvent: #rightClicked ]
        ifFalse: [ super button2Up: aPoint ]!
  
clearTextModified
        "Private - Clear the modified flag on all the
         receiver's TextPanes."
    self allChildrenDo: [ :pane |
        pane isTextPane
            ifTrue: [ pane modified: false ] ]!
  
close
    "Private - Close the window.
	The window will be closed by the container."

    self stopReceivingMessages.
    children size > 0 ifTrue: [ children do: [ :subpane | subpane close ] ].
    graphicsTool := nil.
    handle := nil.  "self destroy."
    self triggerEvent: #closed.!

createWith: aHandle
	" Private - Build the receiver to work with aHandle. "

	"Initialize obsolete instances"
    style isNil ifTrue: [ style := self getStyle ].

	self handle: aHandle.
    self isHandleOk ifFalse: [ ^nil ].

    self initGraphics.
"
    self receiveMessages.
    children size ~= 0 ifTrue: [
        self childrenInBuildOrder do: [ :each |
            (each buildWindow: self) isNil ifTrue: [ ^nil ]
		]
	].
	self subclassWndProc.
"
	self triggerEvent: #created.!

defaultPushButton
        "Private - Answer the subpane which is the default
        push button."
    ^self propertyAt: #defaultPushButton!
 
display
	"Private - Display the receiver's window."

    ^self displayWindow!

displayWindow
	"Private - Let the owner process the display event"

	| icon |
    ((self handlesEvent: #display)
     or: [ self hasActionForEvent: #display ])
    ifTrue: [
		self event: #display.
		self triggerEvent: #display.
	]
	ifFalse: [
		self erase.
		icon := self icon.
		icon
			displayAt: self rectangle extent - icon extent // 2
			with: self pen.
	]!
 
erase
	"Erase the contents of the receiver pane."

    graphicsTool erase!
   
escapeKeyInput: aKeyboardInputEvent
        "Private - Respond to the esc keystroke; by default do nothing, may
        be reimplemented by subclasses."!
 
helpManager
        "Private - Answer the HelpManager for the receiver."
    ^self propertyAt: #helpManager!
  
icon
	" Private - Returns the receiver's icon. "

	^Icon runtimeIcon!

initialize
	"Private - Initialize the receiver."

    super initialize.
    mouse := 0 @ 0.
	self fontAttribute: self defaultFont.!

isApplicationWindow
        "Answer true if receiver is a kind of ApplicationWindow."
    ^true!
  
menuTitled: aString
        "Answer the menu from the receiver's menu bar
         whose title is aString.  Case is ignored
         and aString can include '&', '~', or neither."
    ^nil!
   
mouseLocation
        "Answer the mouse location as of the last
         mouse input event received."
    ^mouse dpToLp: graphicsTool handle!

mouseMove: aPoint
        "Private - Mouse has moved to aPoint.
        Let the owner process the event."
    mouse := aPoint.
    self event: #mouseMove.
    ^super mouseMove: aPoint!
   
onChar: char count: count flags: flags
    " Private - Processes message sent to the control window. "

    self wmChar: char with: flags.!
  
onDraw: pDc bounds: bounds invalid: invalid
    " Private - Processes message sent to the control window. "

	self isValid ifTrue: [ self display ].!

onEraseBkgnd: pDc
    " Private - Processes message sent to the control window. "

    | backColor aColor oldDC |
    (backColor := self backColor) notNil
        ifTrue: [aColor := backColor]
        ifFalse: [aColor := Color windowBackground ].
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: pDc.
    self
        triggerEvent: #eraseBackground
        withArguments: (Array with: self)
        ifNotHandled: [ graphicsTool erase ].
    graphicsTool handle: oldDC.
    ^1!
 
onKeyDown: char count: count flags: flags
    " Private - Processes message sent to the control window. "

    self wmKeydown: char with: flags.!

onKeyUp: char count: count flags: flags
    " Private - Processes message sent to the control window. "

    self wmKeyup: char with: flags.!

onLButtonDblClk: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    self sendInputEvent: #button1DoubleClick: with: mouse.
!
 
onLButtonDown: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    ( nFlags bitAnd: MkShift ) ~= 0
        ifTrue: [ self sendInputEvent: #button1DownShift: with: mouse ]
        ifFalse: [ self sendInputEvent: #button1Down: with: mouse ].!
 
onLButtonUp: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    ( nFlags bitAnd: MkShift ) ~= 0
        ifTrue: [ self sendInputEvent: #button1UpShift: with: mouse ]
        ifFalse: [ self sendInputEvent: #button1Up: with: mouse ].!
   
onMButtonDblClk: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
"Currently ignored
    ( nFlags bitAnd: MkShift ) ~= 0
        ifTrue: [ self sendInputEvent: #button1UpShift: with: mouse ]
        ifFalse: [ self sendInputEvent: #button1Up: with: mouse ].
"!

onMButtonDown: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
"Currently ignored
    ( nFlags bitAnd: MkShift ) ~= 0
        ifTrue: [ self sendInputEvent: #button1UpShift: with: mouse ]
        ifFalse: [ self sendInputEvent: #button1Up: with: mouse ].
"!
  
onMButtonUp: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
"Currently ignored
    ( nFlags bitAnd: MkShift ) ~= 0
        ifTrue: [ self sendInputEvent: #button1UpShift: with: mouse ]
        ifFalse: [ self sendInputEvent: #button1Up: with: mouse ].
"!

onMouseMove: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    (nFlags bitAnd: MkLbutton) ~= 0 ifTrue: [
        self sendMouseMoveInputEvent: #button1Move: with: mouse.
        ^nil ].
    (nFlags bitAnd: MkRbutton) ~= 0 ifTrue: [
        self sendMouseMoveInputEvent: #button2Move: with: mouse.
        ^nil ].
    self sendMouseMoveInputEvent: #mouseMove: with: mouse.
    ^nil!
 
onRButtonDblClk: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    self
        sendInputEvent: #button2DoubleClick:
        with: mouse!
  
onRButtonDown: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    self
        sendInputEvent: #button2Down:
        with: mouse!
   
onRButtonUp: nFlags x: x y: y
    " Private - Processes message sent to the control window. "

	mouse x: x; y: y.
    self
        sendInputEvent: #button2Up:
        with: mouse!
   
onTimer: nIDEvent
    " Private - Processes message sent to the control window. "

    self propertyAt: #timerID put: nIDEvent.
    self event: #timer.
    self triggerEvent: #timer: with: nIDEvent.
    self propertyAt: #timerID put: nil.
    ^nil!
 
rectangle
	"Answer the bounding rectangle of the receiver."

    | result |
	result := super rectangle.
	^result isNil
		ifTrue: [ 0@0 extent: 0@0 ]
		ifFalse: [ result ]!
  
sizeChanged: extent
	" Private - The size of the receiver has been changed to extent. "

	rectangle isNil ifTrue: [ ^self ].
	^super sizeChanged: extent!
   
startTimer: idInteger period: millisecondsInteger
	"Start a timer identified by anInteger. A #wmTimer:with:
	message will be sent to the receiver every millisecondsInteger.

	WARNING: TO BE CHECKED - Subclasified here to handle OS errors silently."

    [ super startTimer: idInteger period: millisecondsInteger ]
	on: Error do: [].!

statusPane
        "Private - Answer the status pane if any, else answer nil."
    children isNil ifTrue: [ ^nil ].
    ^children detect: [ :c | c isStatusPane ] ifNone: [ nil ]!
   
updateSliders
        "Private - don't need to update scrollbars, since host controls
        do it themselves."! !



!ActivexCoordinator class methods !

buildView: aView forModel: aCoordinator
    "Create the structure of the window <aView> for the application <aCoordinator>.
	The default action is to do nothing.
	This method can be reimplemented by subclasses."
!
   
createViewFor: aCoordinator
    " Invalid - Create and configure a window for <aCoordinator>.
	Cant' create a window from scratch."

    self invalidMessage.!
  
open
	" Invalid - Build and open a window for a new instance of the receiver.
	Use #openOn: for this kind of objects. "

    self invalidMessage.!
  
open: aVS4WEBComponent
    " Returns an instance of the receiver working on aVS4WEBComponent. "

    ^self open: aVS4WEBComponent with: nil!
 
open: aVS4WEBComponent with: argument
    " Returns an instance of the receiver working on aVS4WEBComponent. "

    ^self
		openOn: aVS4WEBComponent window
		with: argument!
  
openOn: aWindow
    " Private - Open a new instance of the receiver using aWindow as a parent window."

	^self openOn: aWindow with: nil!

openOn: aWindow with: argument
    " Private - Open a new instance of the receiver using aWindow as a parent window."

    | aCoordinator |
    (aCoordinator := self new)
		initialState: argument;
		window: aWindow;
		yourself.
	self buildView: aWindow forModel: aCoordinator.
    ^aCoordinator! !



!ActivexCoordinator methods !
 
window
    " Private - Returns the instance var of the receiver for external manipulation"

    ^window!
 
window: anObject
    " Private - Sets the instance var of the receiver with anObject. (No checking is done)"

    window := anObject! !



!SmalltalkLibraryBinderWrapper class methods !

binderClass
    "Returns the instance var of the receiver
     for external manipulation"

	binderClass isNil ifTrue: [ self initializeBinderClass ].
    ^binderClass!

binderClass: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    binderClass := anObject!
 
initializeBinderClass
	" Private - Initializes the receiver's binderClass"

	binderClass := SmalltalkLibraryBinder.!
 
install
	" Install the receiver as a binder wrapper. "

	self binderClass: SmalltalkLibraryBinder currentClass.
	SmalltalkLibraryBinder currentClass: self.! !



!SmalltalkLibraryBinderWrapper methods !
  
bind
    "Bind the receiver. Answer the bound Library.
	This method can be refined by subclasses."

	^self binder bind!
 
binder
    "Returns the instance var of the receiver
     for external manipulation"

	binder isNil ifTrue: [ self initializeBinder ].
    ^binder!

binder: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    binder := anObject!
   
eventTable
	" Returns the wrapee event table for event registration. "

	^self binder eventTable!

file: aLibraryName
	" Set the file from which to read the library.
	This method can be refined by subclasses."

	^self binder file: aLibraryName!
   
initializeBinder
	" Private - Initializes the receiver's binder"

	binder := self class binderClass new.!

objectStore
	"Answer the ObjectStore for the receiver.
	This method can be refined by subclasses."

	^self binder objectStore! !
